var REFRESH = 30;
var WEB_API_URL = '/ssi-demo/cgi-bin/web_api.cgi';
var node_colors = ['#F5F5DC', // beige
                   '#00BFFF', // deepskyblue
                   '#F08080', // lightcoral
                   '#A9A9A9', // darkgray
                   '#7FFFD4', // aquamarine
                   '#DC143C', // crimson
                   '#BC8F8F', // rosybrown
                   '#20B2AA', // lightseagreen
                   '#90EE90', // lightgreen
                   '#8A2BE2', // blueviolet
                   '#FF0000', // red
                   '#008000', // green
                   '#F5F5F5', // whitesmoke
                   '#FFE4E1', // mistyrose
                   '#E9967A', // darksalmon
                   '#6A5ACD', // slateblue
                   '#FFFAF0', // floralwhite
                   '#C0C0C0', // silver
                   '#48D1CC', // mediumturquoise
                   '#FF4500', // orangered
                   '#A0522D', // sienna
                   '#00FF7F', // springgreen
                   '#F4A460', // sandybrown
                   '#4169E1', // royalblue
                   '#FFDAB9', // peachpuff
                   '#FF69B4', // hotpink
                   '#FF6347', // tomato
                   '#006400', // darkgreen
                   '#FAEBD7', // antiquewhite
                   '#CD853F', // peru
                   '#FFF0F5', // lavenderblush
                   '#FF8C00', // darkorange
                   '#FFE4C4', // bisque
                   '#D2B48C', // tan
                   '#6495ED', // cornflowerblue
                   '#D8BFD8', // thistle
                   '#5F9EA0', // cadetblue
                   '#8FBC8F', // darkseagreen
                   '#FFE4B5', // moccasin
                   '#8B0000', // darkred
                   '#DB7093', // palevioletred
                   '#B8860B', // darkgoldenrod
                   '#DAA520', // goldenrod
                   '#FFD700', // gold
                   '#9370DB', // mediumpurple
                   '#00FF00', // lime
                   '#F0E68C', // khaki
                   '#1E90FF', // dodgerblue
                   '#DDA0DD', // plum
                   '#00FFFF', // cyan
                   '#B0E0E6', // powderblue
                   '#FAF0E6', // linen
                   '#BDB76B', // darkkhaki
                   '#FAFAD2', // lightgoldenrodyellow
                   '#FFFF00', // yellow
                   '#008080', // teal
                   '#808000', // olive
                   '#9ACD32', // yellowgreen
                   '#6B8E23', // olivedrab
                   '#556B2F', // darkolivegreen
                   '#7FFF00', // chartreuse
                   '#008B8B', // darkcyan
                   '#2E8B57'];// seagreen 

var node_vnode_state = {};
var selected_ipaddress = '';
var selected_port = '';

// 1 origin
var server_setting_node_count = 1;

function get_server_setting_list() {
    selected_ipaddress = '';
    selected_port = '';
    $.getJSON(WEB_API_URL, {'service' : 'server_list'}, print_server_setting_list);
}

function print_server_setting_list(data) {
    $('#node_list_header').empty();
    $('#node_list_contents').empty();
    $('#node_status').empty();

    var list = '<span class="default_header">Server Setting List</span>';
    list += '<table>';
    if (data.result) {
        var servers = [];
        for (var i = 0; i < data.servers.length; i++) {
            servers[i] = data.servers[i].ipaddress + ':' + data.servers[i].port;
        }

        servers.sort();

        for (var i = 0; i < servers.length; i++) {
            var index = servers[i].indexOf(':', 0);
            var ipaddress = servers[i].slice(0, index);
            var port = servers[i].slice(index + 1);
            list += '<tr><td><a href="JavaScript:void(0)" onClick="get_node_status(\'' +
                    ipaddress + '\', \'' + port + '\')">' + servers[i] + '</td></tr>';
        }
    } else {
        list += '<tr><td>' + data.msg + '(' + data.status + ')</td></tr>';
    }
    list += '</table>';

    $('#server_setting_list').empty().append(list);
}

function get_node_status(ipaddress, port) {
    $('#node_list').scrollTop(0);
    $('#node_status').scrollTop(0);

    selected_ipaddress = ipaddress;
    selected_port = port;

    $.getJSON(WEB_API_URL, 
              {'service' : 'node_status',
               'ipaddress' : selected_ipaddress, 'port': selected_port},
              print_node_list);
}

function print_node_list(data) {
    print_node_list_header(data);
    print_node_list_contents(data);
    print_node_status(data);
}

function print_node_list_header(data) {
    $('#node_list_header').empty();

    var list = '';
    if (data.result) {
        list += '<tbody>';
        list += '<tr>';
        list += '<td class="srv_label">Server:</td><td class="srv_data" colspan="5">' + data.server.ipaddress + ':' + data.server.port + '</td>';
        list += '</tr>';
        list += '<tr>';
        list += '<td class="srv_label">Network Interface Name:</td><td class="srv_data">' + data.server.interface + '</td>';
        list += '<td class="srv_label">Netmask:</td><td class="srv_data">' + data.server.netmask + '</td>';
        list += '<td class="srv_label">Fakemac:</td><td class="srv_data">';
        if (data.server.fakemac) {
            list += 'O';
        } else {
            list += 'X';
        }
        list += '</td>';
        list += '</tr>';
        list += '<tr>';
        list += '<td class="srv_label">Request Inspector Name:</td><td class="srv_data">' + data.server.ri + '</td>';
        list += '<td class="srv_label">Request Inspector Option:</td><td class="srv_data">' + data.server.ri_opt + '</td>';
        list += '<td class="srv_label">Display Interval:</td><td class="srv_data">'+ REFRESH + 's</td>';
        list += '</tr>';
        list += '</tbody>';
    } else {
        list += '<tr><td>' + data.msg + '(' + data.status + ')</td></tr>';
    }

    $('#node_list_header').append($('<table></table>').attr('id', 't_node_list_header'));
    $('#t_node_list_header').append(list);
}

function print_node_list_contents(data) {
    $('#node_list_contents').empty();

    $('#node_list_contents').prepend($('<table></table>').attr('id', 't_node_list_contents'));
    $('#t_node_list_contents').append($('<tr></tr>').attr('id', 'tr_node_list_contents'));

    if (data.result) {
        var alive_node_list = [];
        var dead_node_list = [];
        for (var i = 0; i < data.server.nodes.length; i++) {
            if (data.server.nodes[i].ready) {
                alive_node_list.push(data.server.nodes[i].hbname);
            } else {
                dead_node_list.push(data.server.nodes[i].hbname);
            }
        }

        // alive node sort
        alive_node_list = unique_arr(alive_node_list);
        alive_node_list.sort();

        // dead node sort
        dead_node_list = unique_arr(dead_node_list);
        dead_node_list.sort();

        // all node
        all_node_list = alive_node_list.concat(dead_node_list);

        var list = '';
        list += '<td><table>';

        // add node button
        list += '<tr>'
        list += '<td></td>'
        if (all_node_list.length < 64) {
            list += '<td><input type="button" value="Add Node" onClick="view_add_node(\'' +
                    data.server.ipaddress + '\', \'' + data.server.port + '\')" /></td>';
        } else {
            list += '<td><input type="button" value="Add Node" disabled /></td>';
        }
        list += '</tr>';

        for (var i = 0; i < all_node_list.length; i++) {
            list += '<tr><td class="node_color" bgcolor="' + node_colors[i] + '"></td><td>'
            list += '<a href="JavaScript:void(0)" onClick="scroll_node(\'' +
                    all_node_list[i] + '\')">' + all_node_list[i] + '</a>';
            if (i <= (alive_node_list.length - 1)) {
                list += '</a>'
            } else {
                list += '(dead)</a>'
            }
            list += '</td></tr>'
        }
        list += '</table></td>';
        $('#tr_node_list_contents').append(list);
    } else {
        var list = '<tr><td>' + data.msg + '(' + data.status + ')</td></tr>';
        $('#t_node_list_contents').append(list);
    }

    $('#tr_node_list_contents').append($('<td></td>').attr('id', 't_pie_graph'));
    $('#tr_node_list_contents').append($('<td></td>').attr('id', 't_pie_graph_dev'));

    print_pie_graphs(data);
}

function print_pie_graphs(data) {
    $('#tr_node_list_contents #t_pie_graph').empty();
    $('#tr_node_list_contents #t_pie_graph_dev').empty();

    // jqPlot
    $('#t_pie_graph').append($('<div></div>').attr('id', 'd_pie_graph'));
    $('#t_pie_graph_dev').append($('<div></div>').attr('id', 'd_pie_graph_dev'));

    print_pie_graph(data);
    print_pie_graph_dev(data);
}

function scroll_node(to) {
    var d_top = $('#node_status').offset().top;
    var n_top = $('#t_' + to).offset().top;
    var s_top = $('#node_status').scrollTop();
    var top = n_top + s_top - d_top;
    $('#node_status').animate({scrollTop: top}, 'slow', 'swing');
}

function print_node_status(data) {
    $('#node_status').empty();

    $('#node_status').prepend($('<table></table>').attr('id', 't_node_status'));

    if (data.result) {
        var alive_node_list = [];
        var dead_node_list = [];
        for (var i = 0; i < data.server.nodes.length; i++) {
            if (data.server.nodes[i].ready) {
                alive_node_list.push(data.server.nodes[i].hbname);
            } else {
                dead_node_list.push(data.server.nodes[i].hbname);
            }
        }

        // alive node sort
        alive_node_list = unique_arr(alive_node_list);
        alive_node_list.sort();

        // alive node only
        var node_obj = {};
        for (var i = 0; i < data.server.nodes.length; i++) {
            node_name = data.server.nodes[i].hbname;
            vnodeid = data.server.nodes[i].vnodeid;
            hashvalue = data.server.nodes[i].hashvalue;
            for (var j = 0; j < alive_node_list.length; j++) {
                if (alive_node_list[j] == node_name) {
                    if (node_name in node_obj) {
                        var tmp = node_obj[node_name];
                        tmp[vnodeid] = hashvalue;
                        node_obj[node_name] = tmp;
                    } else {
                        var tmp = {};
                        tmp[vnodeid] = hashvalue;
                        node_obj[node_name] = tmp;
                    }
                }
            }
        }

        // alive node only
        var server = data.server.ipaddress + ':' + data.server.port;
        for (var i = 0; i < alive_node_list.length; i++) {
            $('#t_node_status').append($('<tr></tr>').attr('id', 't_' + alive_node_list[i]));
            $('#t_' + escape(alive_node_list[i])).append($('<form></form>').attr({'id': 'f_' + alive_node_list[i], 'method': 'post'}));

            var list = '';

            // graph
            list += '<td><table>';
            list += '<tr>';
            list += '<td colspan="10"><span class="node_name">' + alive_node_list[i] + '</span></td>';
            list += '</tr>';
            list += '<tr>';
            list += '<td colspan="10"><img class="img_graph" src="load_monitor/' + alive_node_list[i] + '_cpuusage.png?' + (new Date()).getTime() + '" /></td>';
            list += '</tr>';
            list += '<tr>';
            list += '<td colspan="10"><img class="img_graph" src="load_monitor/' + alive_node_list[i] + '_int_traffic.png?' + (new Date()).getTime() + '" /></td>';
            list += '</tr>';
            list += '<tr>';
            list += '<td colspan="10"><img class="img_graph" src="load_monitor/' + alive_node_list[i] + '_ext_traffic.png?' + (new Date()).getTime() + '" /></td>';
            list += '</tr>';

            // checkbox
            list += '<tr>';
            list += '<td colspan="4">Virtual Nodes</td>';
            list += '<td colspan="6"></td>';
            list += '</tr>';
            list += '<tr>';
            list += '<td colspan="10">';
            list += '<input type="checkbox" onClick="$(this.parentNode.parentNode.parentNode).find(\'input[type=\\\'checkbox\\\']\').attr(\'checked\', this.checked)" />All On/Off';
            list += '</td>';
            list += '</tr>';
            list += '<tr>';
            var vnodeids = node_obj[alive_node_list[i]];
            for (var j = 1; j < 64; j++) {
                var checked = false;
                if (j in vnodeids) {
                    list += '<td><input id="i_apply_vnodeid" name="apply_vnodeid[]" type="checkbox" name="vnode" value="' + j + '" checked>' + j + '</input></td>';
                    checked = true;
                } else {
                    list += '<td><input id="i_apply_vnodeid" name="apply_vnodeid[]" type="checkbox" name="vnode" value="' + j + '">' + j + '</input></td>';
                }
                if ((j % 10) == 0) {
                    list += '</tr>';
                    list += '<tr>';
                }

                if (node_vnode_state[alive_node_list[i]] == null) {
                    node_vnode_state[alive_node_list[i]] = {};
                }
                node_vnode_state[alive_node_list[i]][j] = checked;
            }
            list += '</tr>';
            list += '<tr>';
            list += '<td colspan="6"></td>';
            list += '<td colspan="2">';
            list += '<input type="button" value="Apply" onClick="confirm_apply(\'' + data.server.ipaddress + '\', \'' +
                                                                               data.server.port + '\', \'' +
                                                                               alive_node_list[i] + '\')">';
            list += '</td>';
            list += '<td colspan="2">';
            list += '<input type="button" value="Del Node" onClick="confirm_del_node(\'' + data.server.ipaddress + '\', \'' +
                                                                                     data.server.port + '\', \'' +
                                                                                     alive_node_list[i] + '\')">';
            list += '</td>';
            list += '</tr>';
            list += '</table></td>';

            $('#t_' + escape(alive_node_list[i])).append(list);
        }

        // dead node sort
        dead_node_list = unique_arr(dead_node_list);
        dead_node_list.sort();
        for (var i = 0; i < dead_node_list.length; i++) {
            $('#t_node_status').append($('<tr></tr>').attr('id', 't_' + dead_node_list[i]));
            var list = '<td><table>';
            list += '<tr>';
            list += '<td colspan="10"><span class="node_name">' + dead_node_list[i] + '</span></td>';
            list += '</tr>';
            list += '</table></td>';
            $('#t_' + escape(dead_node_list[i])).append(list);
        }
    } else {
        var list = '<tr><td>' + data.msg + '(' + data.status + ')</td></tr>';
        $('#t_node_status').append(list);
    }
}

function view_add_node(ipaddress, port) {
    if ($('#t_add_node').size() > 0) {
        return;
    }

    var list = '';

    // node name
    list += '<tr><td>';
    list += '<p id="p_validate_tips"></p>';
    list += '</td></tr>';
    list += '<tr><td>';
    list += '<table>';
    list += '<tr><td>Node Name:<input id="i_node_name" name="node_name" type="text" /></td></tr>';
    list += '</table>';
    list += '</td></tr>';

    // checkbox
    list += '<tr><td>';
    list += '<table>';
    list += '<tr>';
    list += '<td colspan="4">Virtual Nodes</td>';
    list += '<td colspan="6"></td>';
    list += '</tr>';
    list += '<tr>';
    list += '<td colspan="10">';
    list += '<input type="checkbox" onClick="$(this.parentNode.parentNode.parentNode).find(\'input[type=\\\'checkbox\\\']\').attr(\'checked\', this.checked)" checked />All On/Off';
    list += '</td>';
    list += '</tr>';
    list += '<tr>';
    for (var i = 1; i < 64; i++) {
        list += '<td><input id="i_add_vnodeid" name="add_vnodeid[]" type="checkbox" value="' + i + '" checked />' + i + '</td>';
        if ((i % 10) == 0) {
            list += '</tr>';
            list += '<tr>';
        }
    }
    list += '</tr>';
    list += '<tr>';
    list += '<td colspan="6"></td>';
    list += '<td colspan="2"><input type="button" value="Add" onClick="confirm_add_node(\'' + ipaddress + '\', \'' + port + '\')"></td>';
    list += '<td colspan="2"><input type="button" value="Cancel" onClick="remove_add_node()"></td>';
    list += '</tr>';
    list += '</table>';
    list += '</td></tr>';

    $('#node_status').prepend($('<form></form>').attr({'id': 'f_add_node', 'method': 'post'}));
    $('#f_add_node').prepend($('<table></table>').attr('id', 't_add_node'));
    $('#t_add_node').append(list);
}

function confirm_apply(ipaddress, port, node_name) {
    var ids = {};
    for (var i = 1; i < 64; i++) {
        ids[i] = false;
    }

    var msg = '<div><table>';
    msg += '<tr><td colspan="5">Node Name: </td><td colspan="15">' + node_name + '</td></tr>';
    $('#t_' + escape(node_name)).find(":checkbox[name^='apply_vnodeid[]']").each(function() {
        var id = $(this).val();
        msg += '<td>' + id + ':</td>';
        if ($(this).attr('checked')) {
            msg += '<td>O</td>';
            ids[id] = true;
        } else {
            msg += '<td>X</td>';
        }

        if ((id % 10) == 0) {
            msg += '</tr>';
            msg += '<tr>';
        }
    });
    msg += '</tr>';
    msg += '</table></div>';

    msg += 'Do you want to apply the ' + node_name + '?';

    var apply_node_result = function(data) {
                                $(this).empty();

                                if (data.result) {
                                    get_node_status(ipaddress, port);
                                    modal_dialog('result', 'apply node sucess.', function(result){});
                                } else {
                                    modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                                }
                            }

    // submit confirm modal dialog
    var modal_func = function(result) {
                         if (result) {
                             var add_ids = [];
                             var del_ids = [];
                             for (var i = 1; i < 64; i++) {
                                 if (ids[i] && !node_vnode_state[node_name][i]) {
                                     add_ids.push(i);
                                 } else if (!ids[i] && node_vnode_state[node_name][i]) {
                                     del_ids.push(i);
                                 }
                             }

                             // send vnode list
                             $.getJSON(WEB_API_URL, 
                                       {'service': 'apply_node',
                                        'ipaddress': ipaddress,
                                        'port': port,
                                        'node': node_name,
                                        'add_vnodeid': add_ids,
                                        'del_vnodeid': del_ids},
                                       apply_node_result);
                         }
                     }

    modal_confirm_dialog('confirm', msg, modal_func);
}

function confirm_del_node(ipaddress, port, node_name) {
    var msg = 'Do you want to delete the ' + node_name + '?';
    var del_node_result = function(data) {
                              $(this).empty();

                              if (data.result) {
                                  get_node_status(ipaddress, port);
                                  modal_dialog('result', 'delete node sucess.', function(result){});
                              } else {
                                  modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                              }
                          }

    // submit confirm modal dialog
    var modal_func = function(result) {
                         if (result) {
                             // send vnode list
                             $.getJSON(WEB_API_URL, 
                                       {'service': 'delete_node',
                                        'ipaddress': ipaddress, 'port': port, 
                                        'node': node_name},
                                       del_node_result);
                         }
                     }

    modal_confirm_dialog('confirm', msg, modal_func);
}

function confirm_add_node(ipaddress, port) {
    var node_name = $('#i_node_name').val();
    if (node_name == undefined || node_name == '') {
        modal_dialog('error', 'Node Name is null.', function(result){});
        return;
    } else if (node_name.match(/([ #;&,.+*~\':"!^$%[\]()=>|\/])/i)) {
        modal_dialog('error', 'Node Name is invalid value.', function(result){});
        return;
    }

    var ids = [];
    var msg = '<div><table>';
    msg += '<tr><td colspan="5">Node Name: </td><td colspan="15">' + node_name + '</td></tr>';
    $("#f_add_node :checkbox[name^='add_vnodeid']").each(function() {
        var id = $(this).val();
        msg += '<td>' + id + ':</td>';
        if ($(this).attr('checked')) {
            msg += '<td>O</td>';
            ids.push(id);
        } else {
            msg += '<td>X</td>';
        }

        if ((id % 10) == 0) {
            msg += '</tr>';
            msg += '<tr>';
        }
    });
    msg += '</tr>';
    msg += '</table></div>';

    msg += 'Do you want to add the node?';

    var add_node_result = function(data) {
                              $(this).empty();
                              remove_add_node();

                              if (data.result) {
                                  get_node_status(ipaddress, port);
                                  modal_dialog('result', 'add node sucess.', function(result){});
                              } else {
                                  modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                              }
                          }

    // submit confirm modal dialog
    var modal_func = function(result) {
                         if (result) {
                             // send vnode list
                             $.getJSON(WEB_API_URL, 
                                       {'service': 'add_node',
                                        'ipaddress': ipaddress, 'port': port,
                                        'node': node_name, 'add_vnodeid': ids},
                                       add_node_result);
                         }
                     }

    modal_confirm_dialog('confirm', msg, modal_func);
}

function confirm_clear() {
    var msg = 'Do you want to clear?';
    var clear_result = function(data) {
                           $(this).empty();

                           if (data.result) {
                               get_server_setting_list();
                               modal_dialog('result', 'clear sucess.', function(result){});
                           } else {
                               modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                           }
                       }

    // submit confirm modal dialog
    var modal_func = function(result) {
                         if (result) {
                             $.getJSON(WEB_API_URL, 
                                       {'service': 'clear'},
                                       clear_result);
                         }
                     }

    modal_confirm_dialog('confirm', msg, modal_func);
}

function remove_add_node() {
    $('#t_add_node').remove();
}

function print_pie_graph(data) {
    if (data.result) {
        if (data.server.nodes == undefined || data.server.nodes.length < 1) {
            return;
        }

        var alive_node_list = [];
        var dead_node_list = [];
        var valid_node_list = [];
        for (var i = 0; i < data.server.nodes.length; i++) {
            if (data.server.nodes[i].ready) {
                alive_node_list.push(data.server.nodes[i].hbname);
                if (data.server.nodes[i].hashvalue != undefined) {
                    valid_node_list.push([data.server.nodes[i].hbname,
                                          data.server.nodes[i].hashvalue]);
                }
            } else {
                dead_node_list.push(data.server.nodes[i].hbname);
            }
        }

        if (valid_node_list.length < 1) {
            return;
        }

        // alive node sort
        alive_node_list = unique_arr(alive_node_list);
        alive_node_list.sort();

        // dead node sort
        dead_node_list = unique_arr(dead_node_list);
        dead_node_list.sort();

        // all node
        all_node_list = alive_node_list.concat(dead_node_list);

        var node_graph_colors = {};
        for (var i = 0; i < all_node_list.length; i++) {
            node_graph_colors[all_node_list[i]] = node_colors[i]
        }

        var tmp_hash = {};
        var accur = 3;
        var max = parseInt('ffffffffffffffffffffffffffffffff'.slice(0, accur), 16) + 1;
        for (var i = 0; i < valid_node_list.length; i++) {
            node_name = valid_node_list[i][0];
            hashvalue = parseInt(valid_node_list[i][1].slice(0, accur), 16);

            var tmp = 0;
            if (i == (valid_node_list.length - 1)) {
                var first_hashvalue = parseInt(valid_node_list[0][1].slice(0, accur), 16);
                tmp = ((max - hashvalue) + first_hashvalue);
            } else {
                var next_hashvalue = parseInt(valid_node_list[i + 1][1].slice(0, accur), 16);
                tmp = next_hashvalue - hashvalue;
            }

            if (tmp_hash[node_name]) {
                tmp_hash[node_name] = tmp_hash[node_name] + tmp;
            } else {
                tmp_hash[node_name] = tmp;
            }
        }

        // jqPlot
        var graph_data = [];
        var pie_graph_colors = [];
        for (var i = 0; i < all_node_list.length; i++) {
            var key = all_node_list[i];
            var value = tmp_hash[key];
            if (value != undefined && value > 0) {
                graph_data.push([key, value]);
                pie_graph_colors.push(node_graph_colors[key]);
            }
        }

        $.jqplot('d_pie_graph', [graph_data], {
            title: {
                text: 'L4 Load Balancing Weights',
                show: true
            },
            grid: {
                drawGridLines: false,
                shadow: false,
                borderWidth: 0,
                background: '#FFFFFF'
            },
            seriesColors: pie_graph_colors,
            seriesDefaults: {
                renderer: $.jqplot.PieRenderer,
                rendererOptions: {
                    sliceMargin: 1,
                    showDataLabels: true,
                    dataLabelThreshold: 0,
                    dataLabelNudge: 70,
                    dataLabelFormatString: '%s %.2f%%',
                    startAngle: -90
                }
            },
            legend: {
                show: false
            }
        });
    }
}

function print_pie_graph_dev(data) {
    if (data.result) {
        if (data.server.nodes == undefined || data.server.nodes.length < 1) {
            return;
        }

        $.jqplot.config.enablePlugins = true;

        var alive_node_list = [];
        var dead_node_list = [];
        var valid_node_list = [];
        for (var i = 0; i < data.server.nodes.length; i++) {
            if (data.server.nodes[i].ready) {
                alive_node_list.push(data.server.nodes[i].hbname);
                if (data.server.nodes[i].hashvalue != undefined) {
                    valid_node_list.push([data.server.nodes[i].hbname,
                                          data.server.nodes[i].vnodeid,
                                          data.server.nodes[i].hashvalue]);
                }
            } else {
                dead_node_list.push(data.server.nodes[i].hbname);
            }
        }

        if (valid_node_list.length < 1) {
            return;
        }

        // alive node sort
        alive_node_list = unique_arr(alive_node_list);
        alive_node_list.sort();

        // dead node sort
        dead_node_list = unique_arr(dead_node_list);
        dead_node_list.sort();

        // all node
        all_node_list = alive_node_list.concat(dead_node_list);

        var node_graph_colors = {};
        for (var i = 0; i < all_node_list.length; i++) {
            node_graph_colors[all_node_list[i]] = node_colors[i]
        }

        var accur = 3;
        var max = parseInt('ffffffffffffffffffffffffffffffff'.slice(0, accur), 16) + 1;
        var sum = 0;
        var graph_data = [];
        var custom_colors = [];
        for (var i = 0; i < valid_node_list.length; i++) {
            node_name = valid_node_list[i][0];
            vnodeid = valid_node_list[i][1];
            hashvalue = parseInt(valid_node_list[i][2].slice(0, accur), 16);

            if (i == 0) {
                var last_node_name = valid_node_list[valid_node_list.length - 1][0];
                var last_vnodeid = valid_node_list[valid_node_list.length - 1][1];
                sum += hashvalue;
                graph_data[i] = [last_node_name + ':' + last_vnodeid, hashvalue];
                custom_colors[i] = node_graph_colors[last_node_name];
            } else {
                var prev_node_name = valid_node_list[i - 1][0];
                var prev_vnodeid = valid_node_list[i - 1][1];
                var prev_hashvalue = parseInt(valid_node_list[i - 1][2].slice(0, accur), 16);
                sum += (hashvalue - prev_hashvalue);
                graph_data[i] = [prev_node_name + ':' + prev_vnodeid, hashvalue - prev_hashvalue];
                custom_colors[i] = node_graph_colors[prev_node_name];
            }

            // last node
            if (i == (valid_node_list.length - 1)) {
                sum += (max - hashvalue);
                graph_data[i + 1] = [node_name + ':' + vnodeid, max - hashvalue];
                custom_colors[i + 1] = node_graph_colors[node_name];
            }
        }

				var labels = new Array();
        for (var i = 0; i < graph_data.length; i++) {
            var label = graph_data[i][0];
            var value = graph_data[i][1];
            graph_data[i] = [label, round_val(sum, value)];
            labels.push(label.concat(' ').concat(graph_data[i][1]));
        }

        labels.constructor = Array;
        // jqPlot
        $.jqplot('d_pie_graph_dev', [graph_data], {
            title: {
                text: 'Consistent Hashing',
                show: true
            },
            grid: {
                drawGridLines: false,
                shadow: false,
                borderWidth: 0,
                background: '#FFFFFF'
            },
            seriesColors: custom_colors,
            seriesDefaults: {
                renderer: $.jqplot.PieRenderer,
                rendererOptions: {
                    sliceMargin: 1,
                    showDataLabels: true,
                    dataLabels: labels,
                    dataLabelThreshold: 0,
                    dataLabelNudge: 70,
                    dataLabelFormatString: '%s%%',
                    startAngle: -90
                }
            },
            legend: {
                show: false
            }
        });
    }
}

function add_server_setting() {
    var msg = '<table id="t_add_server_setting">';
    msg += '<tr><td>';
    msg += '<p id="p_validate_tips"></p>';
    msg += '</td></tr>';
    msg += '<tr><td>';
    msg += '<table>';
    msg += '<tr><td>IP Address</td><td><input id="i_ipaddress" name="ipaddress" type="text" /></td></tr>';
    msg += '<tr><td>Port Number</td><td><input id="i_port_number" name="port_number" type="text" /></td></tr>';
    msg += '<tr><td>Network Interface Name</td><td><input id="i_if_name" name="if_name" type="text" /></td></tr>';
    msg += '<tr><td>Netmask</td><td><input id="i_netmask" name="netmask" type="text" /></td></tr>';
    msg += '<tr><td>Fakemac</td><td><input id="i_fakemac" name="fakemac" type="checkbox" /></td></tr>';
    msg += '<tr><td>Request Inspector Name</td><td><input id="i_ri_name" name="ri_name" type="text" /></td></tr>';
    msg += '<tr><td>Request Inspector Option</td><td><input id="i_ri_option" name="ri_option" type="text" /></td></tr>';
    msg += '</table>';
    msg += '</td></tr>';
    msg += '<tr><td class="node_delim" colspan="10"></td></tr>';

    msg += '<tr id="t_server_setting_add_node">';
    msg += '<td colspan="2"><input type="button" value="Add Node" onClick="add_node_table()"></td>';
    msg += '<td colspan="8"></td>';
    msg += '</tr>';
    msg += '</table>';

    var dialog = $('<div id="d_add_server_setting" class="dialog">' + msg + '</div>');
    dialog.dialog({
        modal: true,
        draggable: false,
        resizable: false,
        title: 'add server setting',
        width: 500,
        height: 500,
        buttons: {
            'OK': function() {
                      var tips = $('#t_add_server_setting #p_validate_tips');
                      var ipaddress = $('#t_add_server_setting #i_ipaddress').val();
                      var port_num = $('#t_add_server_setting #i_port_number').val();
                      var if_name = $('#t_add_server_setting #i_if_name').val();
                      var netmask = $('#t_add_server_setting #i_netmask').val();
                      var fakemac = $('#t_add_server_setting #i_fakemac').is(':checked');
                      var ri_name = $('#t_add_server_setting #i_ri_name').val();
                      var ri_option = $('#t_add_server_setting #i_ri_option').val();

                      // nodes value
                      var nodes = {};
                      $('#t_add_server_setting .d_node_table').each(function() {
                          var node_name = $(this).find('#i_node_name').val();
                          if (node_name != undefined && node_name.length > 0) {
                              var ids = [];
                              $(this).find(":checkbox[name^='add_vnodeid']").each(function() {
                                  var id = $(this).val();
                                  if ($(this).attr('checked')) {
                                      ids[id] = true;
                                  } else {
                                      ids[id] = false;
                                  }
                              });
                              nodes[node_name] = ids;
                          }
                      });

                      function update_tips(msg) {
                          tips.text(msg).addClass('ui-state-highlight');
                      }

                      function check_require_value(str, name) {
                          if (str == undefined || str == '') {
                              update_tips(name + ' is null.');
                              return false;
                          } else if (str.match(/([ #;&,+*~\':"!^$%[\]()=>|\/])/i)) {
                              update_tips(name + ' is invalid value.');
                              return false;
                          }
                          return true;
                      }

                      function check_value(str, name) {
                          if (str.match(/([#;&,+*~\':"!^$%[\]()=>|\/])/i)) {
                              update_tips(name + ' is invalid value.');
                              return false;
                          }
                          return true;
                      }

                      var valid = true;
                      valid = valid && check_require_value(ipaddress, 'IP Address');
                      valid = valid && check_require_value(port_num, 'Port Number');
                      valid = valid && check_require_value(if_name, 'Network Interface Name');
                      valid = valid && check_value(netmask, 'Netmask');
                      valid = valid && check_require_value(ri_name, 'Request Inspector Name');
                      valid = valid && check_value(ri_option, 'Request Inspector Option');
                      for (node in nodes) {
                          valid = valid && check_require_value(node, 'Node Name');
                          if (!valid) {
                              break;
                          }
                      }

                      if (valid) {
                          confirm_add_server_setting(ipaddress,
                                                     port_num,
                                                     if_name,
                                                     netmask,
                                                     fakemac,
                                                     ri_name,
                                                     ri_option,
                                                     nodes);
                          server_setting_node_count = 1;
                          $(this).empty();
                          $(this).dialog('close');
                      }
                  },
            'Cancel': function() {
                          server_setting_node_count = 1;
                          $(this).empty();
                          $(this).dialog('close');
                      },
            'Help': function() {
                        view_help();
                        server_setting_node_count = 1;
                        $(this).empty();
                        $(this).dialog('close');
                    }
        }
    });
}

function create_node_table(del_button) {
    var msg = '<tr><td>';
    msg += '<table>';
    msg += '<tr><td colspan="2">Node Name</td><td colspan="8"><input id="i_node_name" name="node_name" type="text" /></td></tr>';
    msg += '<tr>';
    msg += '<td colspan="4">Virtual Nodes</td>';
    msg += '<td colspan="6"></td>';
    msg += '</tr>';
    msg += '<tr>';
    msg += '<td colspan="10">';
    msg += '<input type="checkbox" onClick="$(this.parentNode.parentNode.parentNode).find(\'input[type=\\\'checkbox\\\']\').attr(\'checked\', this.checked)" checked />All On/Off';
    msg += '</td>';
    msg += '</tr>';
    msg += '<tr>';
    for (var i = 1; i < 64; i++) {
        msg += '<td><input id="i_add_vnodeid" name="add_vnodeid[]" type="checkbox" value="' + i + '" checked />' + i + '</td>';
        if ((i % 10) == 0) {
            msg += '</tr>';
            msg += '<tr>';
        }
    }
    msg += '</tr>';

    if (del_button) {
        msg += '<tr>';
        msg += '<td colspan="2"><input type="button" value="Del Node" onClick="$(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode).empty()"></td>';
        msg += '</tr>';
    }
    msg += '<tr><td class="node_delim" colspan="10"></td></tr>';

    msg += '</table>';
    msg += '</td></tr>';
    return msg;
}

function add_node_table() {
    // max id 64
    if (server_setting_node_count > 64) {
        return;
    }

    var msg = create_node_table(true);
    var id = 'd_node_table' + server_setting_node_count;
    $('#t_add_server_setting #t_server_setting_add_node').before($('<div></div>').attr({'id': id, 'class': 'd_node_table'}));
    $('#t_add_server_setting #' + id).append(msg);

    server_setting_node_count++;
}

function confirm_add_server_setting(ipaddress, port_num, if_name,
                                    netmask, fakemac, ri_name, ri_option, nodes) {
    var msg = '<div><table>';
    msg += '<tr><td>';
    msg += '<table>';
    msg += '<tr><td colspan="5">IP Address: </td><td colspan="15">' + ipaddress + '</td></tr>';
    msg += '<tr><td colspan="5">Port Number: </td><td colspan="15">' + port_num + '</td></tr>';
    msg += '<tr><td colspan="5">Network Interface Name: </td><td colspan="15">' + if_name + '</td></tr>';
    msg += '<tr><td colspan="5">Netmask: </td><td colspan="15">' + netmask + '</td></tr>';
    msg += '<tr><td colspan="5">Fakemac: </td><td colspan="15">';
    if (fakemac) {
        msg += 'O';
    } else {
        msg += 'X';
    }
    msg += '</td></tr>';
    msg += '<tr><td colspan="5">Request Inspector Name: </td><td colspan="15">' + ri_name + '</td></tr>';
    msg += '<tr><td colspan="5">Request Inspector Option: </td><td colspan="15">' + ri_option + '</td></tr>';
    msg += '</table>';
    msg += '</td></tr>';

    // nodes
    for (node in nodes) {
        msg += '<tr><td>';
        msg += '<table>';
        msg += '<tr><td colspan="5">Node Name: </td><td colspan="15">' + node + '</td></tr>';
        var ids_arr = [];
        for (var i = 1; i < 64; i++) {
            msg += '<td>' + i + ':</td>';
            if (nodes[node][i]) {
                msg += '<td>O</td>';
                ids_arr.push(i);
            } else {
                msg += '<td>X</td>';
            }

            if ((i % 10) == 0) {
                msg += '</tr>';
                msg += '<tr>';
            }
        }
        msg += '</tr>';
        msg += '</table>';
        msg += '</td></tr>';
    }
    msg += '</table></div>';

    msg += 'Do you want to add the server setting?';

    var add_server_setting = function(data) {
                                 if (data.result) {
                                     get_server_setting_list();
                                     modal_dialog('result', 'add server setting sucess.', function(result){});
                                 } else {
                                     modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                                 }
                             }

    // post data
    var post_data = {};
    post_data['service'] = 'add_server_setting';
    post_data['ipaddress'] = ipaddress ;
    post_data['port'] = port_num;
    post_data['if_name'] = if_name;
    if (netmask != undefined && netmask.length > 0 ) {
        post_data['netmask'] = netmask;
    }
    if (fakemac != undefined) {
        post_data['fakemac'] = fakemac;
    }
    post_data['ri_name'] = ri_name;
    if (ri_option != undefined && ri_option.length > 0) {
        post_data['ri_option'] = ri_option;
    }
    var node_name_arr = [];
    for (node in nodes) {
        node_name_arr.push(node);
        post_data[node + '_vnodeid'] = nodes[node];
    }
    if (node_name_arr.length > 0) {
        post_data['host_name'] = node_name_arr;
    }

    // submit confirm modal dialog
    var modal_func = function(result) {
                         if (result) {
                             $.post(WEB_API_URL, post_data, add_server_setting, 'json');
                         }
                     }

    modal_confirm_dialog('confirm', msg, modal_func);
}

function load_setting() {
    var msg = '<table id="t_load_setting">';
    msg += '<tr><td>';
    msg += '<p id="p_validate_tips"></p>';
    msg += '</td></tr>';
    msg += '<tr><td>';
    msg += '<table>';
    msg += '<tr><td>File Path</td><td><input id="i_load_file" name="load_file" type="file" /></td></tr>';
    msg += '</table>';
    msg += '</td></tr>';

    var result = function(data) {
                     if (data.result) {
                         get_server_setting_list();
                         modal_dialog('result', 'load server setting sucess.', function(result){});
                     } else {
                         modal_dialog('result', data.msg + '(' + data.status + ')', function(result){});
                     }
                 }

    var dialog = $('<div class="dialog">' + msg + '</div>');
    dialog.dialog({
        modal: true,
        draggable: false,
        resizable: false,
        title: 'load setting',
        width: 400,
        height: 200,
        buttons: {
            'OK': function() {
                      $('#t_load_setting #i_load_file').upload(WEB_API_URL,
                                                               'service=load_setting',
                                                               result,
                                                               'json');
                      $(this).empty();
                      $(this).dialog('close');
                  },
            'Cancel': function() {
                          $(this).empty();
                          $(this).dialog('close');
                      }
        }
    });
}

function view_help() {
    window.open('help/help.html',
                'DTS Cluster Configuration Help',
                'width=800, height=600, resizable=yes, scrollbars=yes');
}

function view_manual() {
    window.open('manual/index.html',
                'DTS Cluster Manuals',
                'width=800, height=600, resizable=yes, scrollbars=yes');
}


/*
 * common
 */
function modal_confirm_dialog(title, msg, func) {
    var dialog = $('<div class="dialog">' + msg + '</div>');
    dialog.dialog({
        modal: true,
        draggable: false,
        resizable: false,
        title: title,
        width: 450,
        height: 520,
        buttons: {
            'OK': function() {
                       $(this).empty();
                       $(this).dialog('close');
                       func(true);
                  },
            'Cancel': function() {
                          $(this).empty();
                          $(this).dialog('close');
                          func(false);
                      }
        }
    });
}

function modal_dialog(title, msg, func) {
    var dialog = $('<div class="dialog">' + msg + '</div>');
    dialog.dialog({
        modal: true,
        draggable: false,
        resizable: false,
        title: title,
        width: 300,
        height: 200,
        buttons: {
            'OK': function() {
                       $(this).empty();
                       $(this).dialog('close');
                       func(true);
                  }
        }
    });
}

function escape(str) {
    return str.replace(/([ #;&,.+*~\':"!^$%[\]()=>|\/])/g,'\\$1') ;
}

function unique_arr(arr) {
    var tmp = {};
    var unique_arr = [];

    for (var i = 0; i < arr.length; i++) {
        var value = arr[i];
        if (!(value in tmp)) {
            tmp[value] = true;
            unique_arr.push(value);
        }
    }

    return unique_arr;
}

function round_val(sum, value) {
    var tmp = (value / sum) * 100
    tmp = tmp * 100;
    tmp = Math.floor(tmp);
    tmp = tmp / 100;
    return tmp;
}

function img_graph_update() {
    var imgs = $('.img_graph').get();
    for (var i = 0; i < imgs.length; i++) {
        var index = imgs[i].src.indexOf('?');
        imgs[i].src = imgs[i].src.slice(0, index) + '?' + (new Date()).getTime();
    }
}

function node_list_update() {
    if (selected_ipaddress != '' && selected_port != '') {
        $.getJSON(WEB_API_URL, 
                  {'service': 'node_status',
                   'ipaddress': selected_ipaddress, 'port': selected_port},
                  print_node_list_contents);
    }
}

// page load
$(function() {
    get_server_setting_list();
});

setInterval(img_graph_update, REFRESH * 1000);
setInterval(node_list_update, REFRESH * 1000);

